/*=============================================================================
author        : Walter Schreppers
filename      : gen.cpp
created       : 4/2/2005 at 23:04:14
modified      : 
version       : 
copyright     : Walter Schreppers
bugreport(log): 
=============================================================================*/

#include "gen.h"
#include <stdlib.h>


/*-----------------------------------------------------------------------------
name        : init
description : initialize private locals
parameters  : 
return      : void
exceptions  : 
algorithm   : trivial
-----------------------------------------------------------------------------*/
void Gen::init(){
  this->clear();
}


/*-----------------------------------------------------------------------------
name        : Gen
description : constructor
parameters  : 
return      : 
exceptions  : 
algorithm   : trivial
-----------------------------------------------------------------------------*/
Gen::Gen(){
  init();
}


/*-----------------------------------------------------------------------------
name        : ~Gen
description : destructor
parameters  : 
return      : 
exceptions  : 
algorithm   : trivial
-----------------------------------------------------------------------------*/
Gen::~Gen(){
  this->clear();
}


/*-----------------------------------------------------------------------------
name        : operator=
description : 
parameters  : const Gen& m
return      : Gen&
exceptions  : 
algorithm   : trivial
-----------------------------------------------------------------------------*/
Gen& Gen::operator=( const Gen& m ){
  if( this != &m ){
    //copy values of private locals
    for( Gen::size_type i=0; i<m.size(); i++ ){
      if( this->size() < i ) this->push_back( m[i] );
      else (*this)[i] = m[i];
    }
  }
  return *this;
}


/*-----------------------------------------------------------------------------
name        : operator<<
description : output operator
parameters  : ostream& os, const Gen& m
return      : ostream&
exceptions  : 
algorithm   : trivial
-----------------------------------------------------------------------------*/
ostream& operator<<( ostream& os, const Gen& m ){
  for( Gen::const_iterator p=m.begin(); p!=m.end();++p){
    os << *p;
  }
  os<<endl;
  return os;
}


/*-----------------------------------------------------------------------------
name        : operator>>
description : input operator
parameters  : istream& is, Gen& m
return      : istream&
exceptions  : 
algorithm   : trivial
-----------------------------------------------------------------------------*/
istream& operator>>( istream& is, Gen& m ){
  double gen;
  while( !is.eof() ){
    is >> gen;
    m.push_back( gen );
  }
  return is;
}


double Gen::Switch(){
  double fScale=(10.0*rand()/(RAND_MAX+1.0));
  double val=fScale - 5.0; //between -1 and 1
  //cout << "  val= "<<val;
  return val;
}

void Gen::mutate(){	
  double epsilon=0.0001; //the accuracy or stepsize of mutation (smaller takes longer but gives more accuracy). Bigger walks faster but with less accuracy
   
  int j=1+(int) (10.0*rand()/(RAND_MAX+1.0));
  for( Gen::iterator p=this->begin(); p!=this->end();++p){
    if( j>5 ) *p +=epsilon;
    else *p-=epsilon;
  }
}

void Gen::Random(){
  for( Gen::iterator p=this->begin(); p!=this->end();++p){
    *p =  Switch();
  }
}

void Gen::crossover( Gen& m ){
  if( this->size() != m.size() ){
    cerr<<"Gen sizes differ!"<<endl;
    return;
  }
  
  Gen::size_type middle;
  middle = this->size() / 2;
  
  double tmp,tmp2;
  
  for( Gen::size_type i=0; i<middle; i++ ){
    tmp = (*this)[i];
    tmp2 = m[i];
    (*this)[i] = tmp2;
    m[i]=tmp;     
  }
  
}


//we take xpos to be the addition of all the doubles in genstring
double Gen::XPos(){
  double xpos=0;
  for( Gen::const_iterator p=this->begin();p!=this->end(); ++p ){
    xpos+=*p;
  }
  return xpos;
}


