#include "fitness.h"
#include <limits.h>
#include <iostream>
using namespace std;


#define GENES_SIZE 20

int main(){
  vector<Gen> genes;
  
  for( int i=0;i<GENES_SIZE;i++){
    Gen m;
    for( int j=0; j<10;j++){
      double d;
      m.push_back( d );
    }
    m.Random();
    genes.push_back( m ); 
  }
  
  
  Fitness fitness;
  double maxFitness=LONG_MIN;
  double prevFitness=0;
  int maxpos=-1;
  
  while( prevFitness!=maxFitness ){ //or while true to keep on searching longer...
      prevFitness=maxFitness;

      //find best dude ;)
      for( int i=0;i<GENES_SIZE; i++ ){
        double fit=fitness.calculate( genes[i] );
        if( fit > maxFitness ){
          maxpos=i;
          maxFitness=(double)fit;
        }
      }
      
      if( maxpos < 0 ){
        cerr<<"no maximum element found in gene pool?"<<endl;
        return 1;
      }
      
      Gen theBest = genes[maxpos];
      
      //copy the best dude, matrix style, hello Mr. Anderson 
      for( int i=0;i<GENES_SIZE; i++ ){
        genes[i] = theBest;
        genes[i].mutate();
      }
      
      cout << "max fitness=" << maxFitness << " at xpos="<< genes[maxpos].XPos() << endl;
  }

  return 0;
}

